
// ThreadedScoreHandler.java
// Andrew Davison, April 2005, ad@fivedots.coe.psu.ac.th

/* Vláknový obsluhovač volaný objektem typu ThreadedScoreServer 
   ke zpracování požadavků klienta.

   Rozumí vstupní zprávě ve tvaru:
		get					   -- vrací seznam nejvyšších skóre
        score name & score &   -- přidá skóre pro dané jméno
		bye					   -- ukončí spojení s klientem
*/

import java.io.*;
import java.net.*;


public class ThreadedScoreHandler extends Thread
{
  private Socket clientSock;
  private String cliAddr;
  private HighScores hs;

  public ThreadedScoreHandler(Socket s, String cliAddr, HighScores hs)
  {
    clientSock = s;  
    this.cliAddr = cliAddr;
    this.hs = hs;
    System.out.println("Spojení od klienta z adresy " + cliAddr);
  }


  public void run()
  {
    try {
      // Získej V/V proudy ze socket
      BufferedReader in  = new BufferedReader( 
	  		new InputStreamReader( clientSock.getInputStream() ) );
      PrintWriter out = 
			new PrintWriter( clientSock.getOutputStream(), true );  // autoflush

      // komunikuj s klientem
      processClient(in, out);
 
      // Uzavři spojení s klientem
      clientSock.close();
      System.out.println("Klient (" + cliAddr + ") spojení uzavřeno\n");
    }
    catch(Exception e)
    {  System.out.println(e);  }
  }  // konec metody: run()


   private void processClient(BufferedReader in, PrintWriter out)
   // Zastaví, když se uzavře vstupní proud (je null) nebo když přišla zpráva "bye"
   // Jinak předá vstupní zprávu metodě doRequest()
   {
     String line;
     boolean done = false;
     try {
       while (!done) {
         if((line = in.readLine()) == null)
           done = true;
         else {
           System.out.println("Zpráva od klienta: " + line);
           if (line.trim().equals("bye"))
             done = true;
           else 
             doRequest(line, out);
         }
       }
     }
     catch(IOException e)
     {  System.out.println(e);  }
   }  // konec metody: processClient()


  private void doRequest(String line, PrintWriter out)
  /*  Vstupní řádek může vypadat buď takto:
             "score name & score &"
      nebo takto:
            "get"
  */
  {
    if (line.trim().toLowerCase().equals("get")) {
      System.out.println("Zpracovávám 'get'");
      out.println( hs.toString() );
    }
    else if ((line.length() >= 6) &&     // "score "
        (line.substring(0,5).toLowerCase().equals("score"))) {
      System.out.println("Zpracovávám 'score'");
      hs.addScore( line.substring(5) );    // odřízni klíčové slovo score
    }
    else
      System.out.println("Ignoruji vstupní řádek");
  }  // konec metody: doRequest()


}  // konec třídy: ThreadedScoreHandler